Index: /trunk/options/SPECIES/SPECIES_013
===================================================================
--- /trunk/options/SPECIES/SPECIES_013	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_013	(revision 20)
@@ -7,10 +7,6 @@
 NO3-aero           Tracer name
 -999.9             Species half life
- 5.0E-06           Below cloud scavenging - A
-0.62               Below cloud scavenging - B
-2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
-0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
-1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
+ 5.0E-06           Wet deposition - A
+0.62               Wet deposition - B
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: /trunk/options/SPECIES/SPECIES_014
===================================================================
--- /trunk/options/SPECIES/SPECIES_014	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_014	(revision 20)
@@ -7,10 +7,6 @@
 I2-131             Tracer name
 691200.0           Species half life
- 8.0E-05           Below cloud scavenging - A
-0.62               Below cloud scavenging - B
-2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
-0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
-1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
+ 8.0E-05           Wet deposition - A
+0.62               Wet deposition - B
  2.7               Dry deposition (gases) - D
 1.0e+05            Dry deposition (gases) - Henrys const.
Index: /trunk/options/SPECIES/SPECIES_015
===================================================================
--- /trunk/options/SPECIES/SPECIES_015	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_015	(revision 20)
@@ -7,10 +7,6 @@
 I-131              Tracer name
 691200.0           Species half life
- 1.0E-04           Below cloud scavenging - A
-0.80               Below cloud scavenging - B
-2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
-0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
-1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
+ 1.0E-04           Wet deposition - A
+0.80               Wet deposition - B
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: /trunk/options/SPECIES/SPECIES_016
===================================================================
--- /trunk/options/SPECIES/SPECIES_016	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_016	(revision 20)
@@ -7,10 +7,6 @@
 Cs-137             Tracer name
 -999.9             Species half life
- 1.0E-04           Below cloud scavenging - A
-0.80               Below cloud scavenging - B
-2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
-0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
-1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
+ 1.0E-04           Wet deposition - A
+0.80               Wet deposition - B
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: /trunk/options/SPECIES/SPECIES_017
===================================================================
--- /trunk/options/SPECIES/SPECIES_017	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_017	(revision 20)
@@ -7,10 +7,6 @@
 Y-91               Tracer name
 5037120.0          Species half life
- 1.0E-04           Below cloud scavenging - A
-0.80               Below cloud scavenging - B
-2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
-0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
-1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
+ 1.0E-04           Wet deposition - A
+0.80               Wet deposition - B
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: /trunk/options/SPECIES/SPECIES_018
===================================================================
--- /trunk/options/SPECIES/SPECIES_018	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_018	(revision 20)
@@ -7,10 +7,6 @@
 Ru-106             Tracer name
 31536000.0         Species half life
- 1.0E-04           Below cloud scavenging - A
-0.80               Below cloud scavenging - B
-2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
-0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
-1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
+ 1.0E-04           Wet deposition - A
+0.80               Wet deposition - B
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: /trunk/options/SPECIES/SPECIES_019
===================================================================
--- /trunk/options/SPECIES/SPECIES_019	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_019	(revision 20)
@@ -7,10 +7,6 @@
 Kr-85              Tracer name
 -999.9             Species half life
--9.9E-09           Below cloud scavenging - A
-                   Below cloud scavenging - B
--9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
--9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
--9.9               In-cloud scavenging - Ci (S_i=Ci/cl)
--9.9               In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
+-9.9E-09           Wet deposition - A
+                   Wet deposition - B
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: /trunk/options/SPECIES/SPECIES_020
===================================================================
--- /trunk/options/SPECIES/SPECIES_020	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_020	(revision 20)
@@ -7,10 +7,6 @@
 Sr-90              Tracer name
 -999.9             Species half life
- 1.0E-04           Below cloud scavenging - A
-0.80               Below cloud scavenging - B
-2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
-0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
-1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
+ 1.0E-04           Wet deposition - A
+0.80               Wet deposition - B
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: /trunk/options/SPECIES/SPECIES_021
===================================================================
--- /trunk/options/SPECIES/SPECIES_021	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_021	(revision 20)
@@ -6,11 +6,7 @@
 ****************************************************************************
 Xe-133             Tracer name
-453168.0           Species half life
--9.9E-09           Below cloud scavenging - A
-                   Below cloud scavenging - B
--9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
--9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
--9.9               In-cloud scavenging - Ci (S_i=Ci/cl)
--9.9               In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
+198720.0           Species half life
+-9.9E-09           Wet deposition - A
+                   Wet deposition - B
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: /trunk/options/SPECIES/SPECIES_022
===================================================================
--- /trunk/options/SPECIES/SPECIES_022	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_022	(revision 20)
@@ -7,10 +7,6 @@
 CO                 Tracer name
 -999.9             Species half life
--9.9E-09           Below cloud scavenging - A
-                   Below cloud scavenging - B
--9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
--9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
--9.9               In-cloud scavenging - Ci (S_i=Ci/cl)
--9.9               In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
+-9.9E-09           Wet deposition - A
+                   Wet deposition - B
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: /trunk/options/SPECIES/SPECIES_024
===================================================================
--- /trunk/options/SPECIES/SPECIES_024	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_024	(revision 20)
@@ -7,10 +7,6 @@
 AIRTRACER             Tracer name
 -999.9             Species half life
--9.9E-09           Below cloud scavenging - A
-                   Below cloud scavenging - B
--9.9E-09           In-cloud scavenging - Ai (cl=Ai*prec**Bi)
--9.9               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
--9.9               In-cloud scavenging - Ci (S_i=Ci/cl)
--9.9               In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
+-9.9E-09           Wet deposition - A
+                   Wet deposition - B
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: /trunk/options/SPECIES/SPECIES_025
===================================================================
--- /trunk/options/SPECIES/SPECIES_025	(revision 30)
+++ /trunk/options/SPECIES/SPECIES_025	(revision 20)
@@ -9,8 +9,4 @@
 2.0E-05            Wet deposition - A
 0.8                Wet deposition - B
-2.0E-7             In-cloud scavenging - Ai (cl=Ai*prec**Bi)
-0.36               In-cloud scavenging - Bi (cl=Ai*prec**Bi)
-0.9                In-cloud scavenging - Ci (S_i=Ci/cl)
-1.                 In-cloud scavenging - Di (wetscav=S_i*prec/3.6E6/clouds_h/Di)
 -9.9               Dry deposition (gases) - D
                    Dry deposition (gases) - Henrys const.
Index: /trunk/src/FLEXPART.f90
===================================================================
--- /trunk/src/FLEXPART.f90	(revision 30)
+++ /trunk/src/FLEXPART.f90	(revision 20)
@@ -45,9 +45,4 @@
   use conv_mod
 
-#ifdef NETCDF_OUTPUT
-  use netcdf_output_mod, only: writeheader_netcdf
-#endif
-
-
   implicit none
 
@@ -65,8 +60,7 @@
   call gasdev1(idummy,rannumb(maxrand),rannumb(maxrand-1))
 
-  ! FLEXPART version string
-  flexversion='Version 9.2 beta (2014-07-01)'
-  verbosity=0
-
+  ! 
+  flexversion='Version 9.1.8  (2013-12-08)'
+  !verbosity=0
   ! Read the pathnames where input/output files are stored
   !*******************************************************
@@ -82,42 +76,48 @@
     call getarg(1,arg1)
     pathfile=arg1
+    verbosity=0
     if (arg1(1:1).eq.'-') then
-      write(pathfile,'(a11)') './pathnames'
-      inline_options=arg1 
+        write(pathfile,'(a11)') './pathnames'
+        inline_options=arg1 
     endif
   case (0)
     write(pathfile,'(a11)') './pathnames'
+    verbosity=0
   end select
   
+    if (inline_options(1:1).eq.'-') then
+      print*, 'inline options=', inline_options       
+      if (trim(inline_options).eq.'-v'.or.trim(inline_options).eq.'-v1') then
+         print*, 'verbose mode 1: additional information will be displayed'
+         verbosity=1
+      endif
+      if (trim(inline_options).eq.'-v2') then
+         print*, 'verbose mode 2: additional information will be displayed'
+         verbosity=2
+      endif
+      if (trim(inline_options).eq.'-i') then
+         print*, 'info mode: will provide run specific information and stop'
+         verbosity=1
+         info_flag=1
+      endif
+      if (trim(inline_options).eq.'-i2') then
+         print*, 'info mode: will provide run specific information and stop'
+         verbosity=2
+         info_flag=1
+      endif
+    endif
+
+
   ! Print the GPL License statement
   !*******************************************************
-  print*,'Welcome to FLEXPART ', trim(flexversion)
-  print*,'FLEXPART is free software released under the GNU General Public License.'
- 
-  if (inline_options(1:1).eq.'-') then
-    if (trim(inline_options).eq.'-v'.or.trim(inline_options).eq.'-v1') then
-       print*, 'Verbose mode 1: display detailed information during run'
-       verbosity=1
-    endif
-    if (trim(inline_options).eq.'-v2') then
-       print*, 'Verbose mode 2: display more detailed information during run'
-       verbosity=2
-    endif
-    if (trim(inline_options).eq.'-i') then
-       print*, 'Info mode: provide detailed run specific information and stop'
-       verbosity=1
-       info_flag=1
-    endif
-    if (trim(inline_options).eq.'-i2') then
-       print*, 'Info mode: provide more detailed run specific information and stop'
-       verbosity=2
-       info_flag=1
-    endif
-  endif
-           
-  if (verbosity.gt.0) then
-    write(*,*) 'call readpaths'
+  print*,'Welcome to FLEXPART', trim(flexversion)
+  print*,'FLEXPART is free software released under the GNU Genera'// &
+       'l Public License.'
+            
+  if (verbosity.gt.0) then
+        WRITE(*,*) 'call readpaths'
   endif 
   call readpaths(pathfile)
+   
  
   if (verbosity.gt.1) then !show clock info 
@@ -131,32 +131,36 @@
   endif
 
+
   ! Read the user specifications for the current model run
   !*******************************************************
 
   if (verbosity.gt.0) then
-    write(*,*) 'call readcommand'
+        WRITE(*,*) 'call readcommand'
   endif
   call readcommand
   if (verbosity.gt.0) then
-    write(*,*) '    ldirect=', ldirect
-    write(*,*) '    ibdate,ibtime=',ibdate,ibtime
-    write(*,*) '    iedate,ietime=', iedate,ietime
-    if (verbosity.gt.1) then   
-      CALL SYSTEM_CLOCK(count_clock, count_rate, count_max)
-      write(*,*) 'SYSTEM_CLOCK',(count_clock - count_clock0)/real(count_rate) !, count_rate, count_max
-    endif     
-  endif
+        WRITE(*,*) '    ldirect=', ldirect
+        WRITE(*,*) '    ibdate,ibtime=',ibdate,ibtime
+        WRITE(*,*) '    iedate,ietime=', iedate,ietime
+        if (verbosity.gt.1) then   
+                CALL SYSTEM_CLOCK(count_clock, count_rate, count_max)
+                WRITE(*,*) 'SYSTEM_CLOCK',(count_clock - count_clock0)/real(count_rate) !, count_rate, count_max
+        endif     
+  endif
+
 
   ! Read the age classes to be used
   !********************************
   if (verbosity.gt.0) then
-    write(*,*) 'call readageclasses'
+        WRITE(*,*) 'call readageclasses'
   endif
   call readageclasses
 
   if (verbosity.gt.1) then   
-    CALL SYSTEM_CLOCK(count_clock, count_rate, count_max)
-    write(*,*) 'SYSTEM_CLOCK',(count_clock - count_clock0)/real(count_rate) !, count_rate, count_max
+                CALL SYSTEM_CLOCK(count_clock, count_rate, count_max)
+                WRITE(*,*) 'SYSTEM_CLOCK',(count_clock - count_clock0)/real(count_rate) !, count_rate, count_max
   endif     
+ 
+
 
   ! Read, which wind fields are available within the modelling period
@@ -164,5 +168,5 @@
 
   if (verbosity.gt.0) then
-    write(*,*) 'call readavailable'
+        WRITE(*,*) 'call readavailable'
   endif  
   call readavailable
@@ -173,5 +177,5 @@
  
   if (verbosity.gt.0) then
-     write(*,*) 'call gridcheck'
+     WRITE(*,*) 'call gridcheck'
   endif
 
@@ -179,18 +183,20 @@
 
   if (verbosity.gt.1) then   
-    CALL SYSTEM_CLOCK(count_clock, count_rate, count_max)
-    write(*,*) 'SYSTEM_CLOCK',(count_clock - count_clock0)/real(count_rate) !, count_rate, count_max
+     CALL SYSTEM_CLOCK(count_clock, count_rate, count_max)
+     WRITE(*,*) 'SYSTEM_CLOCK',(count_clock - count_clock0)/real(count_rate) !, count_rate, count_max
   endif      
-
-  if (verbosity.gt.0) then
-    write(*,*) 'call gridcheck_nests'
+  
+
+  if (verbosity.gt.0) then
+        WRITE(*,*) 'call gridcheck_nests'
   endif  
   call gridcheck_nests
 
+
   ! Read the output grid specifications
   !************************************
 
   if (verbosity.gt.0) then
-    write(*,*) 'call readoutgrid'
+        WRITE(*,*) 'call readoutgrid'
   endif
 
@@ -198,7 +204,7 @@
 
   if (nested_output.eq.1) then
-    call readoutgrid_nest
+          call readoutgrid_nest
     if (verbosity.gt.0) then
-      write(*,*) '# readoutgrid_nest'
+        WRITE(*,*) '# readoutgrid_nest'
     endif
   endif
@@ -226,4 +232,5 @@
   call readlanduse
 
+
   ! Assign fractional cover of landuse classes to each ECMWF grid point
   !********************************************************************
@@ -234,4 +241,6 @@
   call assignland
 
+
+
   ! Read the coordinates of the release locations
   !**********************************************
@@ -242,4 +251,5 @@
   call readreleases
 
+
   ! Read and compute surface resistances to dry deposition of gases
   !****************************************************************
@@ -257,4 +267,5 @@
     print*,'call coordtrafo'
   endif
+
 
   ! Initialize all particles to non-existent
@@ -284,8 +295,10 @@
   endif
 
+
   ! Calculate volume, surface area, etc., of all output grid cells
   ! Allocate fluxes and OHfield if necessary
   !***************************************************************
 
+
   if (verbosity.gt.0) then
     print*,'call outgrid_init'
@@ -294,4 +307,5 @@
   if (nested_output.eq.1) call outgrid_init_nest
 
+
   ! Read the OH field
   !******************
@@ -299,7 +313,7 @@
   if (OHREA.eqv..TRUE.) then
     if (verbosity.gt.0) then
-      print*,'call readOHfield'
+       print*,'call readOHfield'
     endif
-    call readOHfield
+       call readOHfield
   endif
 
@@ -308,21 +322,4 @@
   !******************************************************************
 
-  if (lnetcdfout.eq.1) then 
-#ifdef NETCDF_OUTPUT
-    call writeheader_netcdf(lnest = .false.)
-#endif
-  else 
-    call writeheader
-  end if
-
-  if (nested_output.eq.1) then
-    if (lnetcdfout.eq.1) then
-#ifdef NETCDF_OUTPUT
-      call writeheader_netcdf(lnest = .true.)
-#endif
-    else
-      call writeheader_nest
-    endif
-  endif
 
   if (verbosity.gt.0) then
@@ -335,10 +332,11 @@
   !if (nested_output.eq.1) call writeheader_nest
   if (nested_output.eq.1.and.surf_only.ne.1) call writeheader_nest
+
   if (nested_output.eq.1.and.surf_only.eq.1) call writeheader_nest_surf
   if (nested_output.ne.1.and.surf_only.eq.1) call writeheader_surf
 
-  if (lnetcdfout.ne.1) then
-    open(unitdates,file=path(2)(1:length(2))//'dates')
-  end if
+
+
+  !open(unitdates,file=path(2)(1:length(2))//'dates')
 
   if (verbosity.gt.0) then
@@ -348,4 +346,5 @@
   if ((iout.eq.4).or.(iout.eq.5)) call openouttraj
 
+
   ! Releases can only start and end at discrete times (multiples of lsynctime)
   !***************************************************************************
@@ -355,7 +354,10 @@
   endif
   do i=1,numpoint
-    ireleasestart(i)=nint(real(ireleasestart(i))/real(lsynctime))*lsynctime
-    ireleaseend(i)=nint(real(ireleaseend(i))/real(lsynctime))*lsynctime
+    ireleasestart(i)=nint(real(ireleasestart(i))/ &
+         real(lsynctime))*lsynctime
+    ireleaseend(i)=nint(real(ireleaseend(i))/ &
+         real(lsynctime))*lsynctime
   end do
+
 
   ! Initialize cloud-base mass fluxes for the convection scheme
@@ -379,4 +381,5 @@
   end do
 
+
   ! Calculate particle trajectories
   !********************************
@@ -384,10 +387,10 @@
   if (verbosity.gt.0) then
      if (verbosity.gt.1) then   
-       call system_clock(count_clock, count_rate, count_max)
-       write(*,*) 'System clock',(count_clock - count_clock0)/real(count_rate) !, count_rate, count_max
+       CALL SYSTEM_CLOCK(count_clock, count_rate, count_max)
+       WRITE(*,*) 'SYSTEM_CLOCK',(count_clock - count_clock0)/real(count_rate) !, count_rate, count_max
      endif
      if (info_flag.eq.1) then
-       print*, 'Info only mode (stop)'    
-       stop
+         print*, 'info only mode (stop)'    
+         stop
      endif
      print*,'call timemanager'
@@ -396,12 +399,7 @@
   call timemanager
 
-  write(*,*) 'CONGRATULATIONS: YOU HAVE SUCCESSFULLY COMPLETED A FLEXPART MODEL RUN!'
-
-  ! output wall time
-  if (verbosity .gt. 0) then
-    call system_clock(count_clock,count_rate)
-    tins=(count_clock - count_clock0)/real(count_rate)
-    print*,'Wall time ',tins,'s, ',tins/60,'min, ',tins/3600,'h.'
-  endif
+
+  write(*,*) 'CONGRATULATIONS: YOU HAVE SUCCESSFULLY COMPLETED A FLE&
+       &XPART MODEL RUN!'
 
 end program flexpart
Index: /trunk/src/advance.f90
===================================================================
--- /trunk/src/advance.f90	(revision 30)
+++ /trunk/src/advance.f90	(revision 20)
@@ -463,8 +463,4 @@
       dcwsave=dcwsave+vp*dt
       zt=zt+w*dt*real(ldirect)
-
-      ! HSO/AL: Particle managed to go over highest level -> interpolation error in goto 700
-      !          alias interpol_wind (division by zero)
-      if (zt.ge.height(nz)) zt=height(nz)-100.*eps
 
       if (zt.gt.h) then
@@ -703,14 +699,4 @@
   endif
 
-  ! HSO/AL: Prevent particles from disappearing at the pole
-  !******************************************************************
-
-  if ( yt.lt.0. ) then
-    xt=mod(xt+180.,360.)
-    yt=-yt
-  else if ( yt.gt.real(nymin1) ) then
-    xt=mod(xt+180.,360.)
-    yt=2*real(nymin1)-yt
-  endif
 
   ! Check position: If trajectory outside model domain, terminate it
@@ -718,5 +704,5 @@
 
   if ((xt.lt.0.).or.(xt.ge.real(nxmin1)).or.(yt.lt.0.).or. &
-       (yt.gt.real(nymin1))) then
+       (yt.ge.real(nymin1))) then
     nstop=3
     return
@@ -873,20 +859,9 @@
   endif
 
-  ! HSO/AL: Prevent particles from disappearing at the pole
-  !******************************************************************
-
-  if ( yt.lt.0. ) then
-    xt=mod(xt+180.,360.)
-    yt=-yt
-  else if ( yt.gt.real(nymin1) ) then
-    xt=mod(xt+180.,360.)
-    yt=2*real(nymin1)-yt
-  endif
-
   ! Check position: If trajectory outside model domain, terminate it
   !*****************************************************************
 
   if ((xt.lt.0.).or.(xt.ge.real(nxmin1)).or.(yt.lt.0.).or. &
-       (yt.gt.real(nymin1))) then
+       (yt.ge.real(nymin1))) then
     nstop=3
     return
Index: /trunk/src/calcpv.f90
===================================================================
--- /trunk/src/calcpv.f90	(revision 30)
+++ /trunk/src/calcpv.f90	(revision 20)
@@ -21,5 +21,5 @@
 
 subroutine calcpv(n,uuh,vvh,pvh)
-  !               i  i   i   o
+  !                  i  i   i   o
   !*****************************************************************************
   !                                                                            *
@@ -49,6 +49,6 @@
   integer :: nlck
   real :: vx(2),uy(2),phi,tanphi,cosphi,dvdx,dudy,f
-  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt
-  real :: pvavr,ppml(0:nxmax-1,0:nymax-1,nuvzmax),ppmk(0:nxmax-1,0:nymax-1,nuvzmax)
+  real :: theta,thetap,thetam,dthetadp,dt1,dt2,dt,ppmk
+  real :: pvavr,ppml(nuvzmax)
   real :: thup,thdn
   real,parameter :: eps=1.e-5, p0=101325
@@ -62,13 +62,4 @@
   ! Loop over entire grid
   !**********************
-  do kl=1,nuvz
-    do jy=0,nymin1
-      do ix=0,nxmin1
-         ppml(ix,jy,kl)=akz(kl)+bkz(kl)*ps(ix,jy,1,n)
-      enddo
-    enddo
-  enddo
-  ppmk=(100000./ppml)**kappa
-
   do jy=0,nymin1
     if (sglobal.and.jy.eq.0) goto 10
@@ -115,4 +106,8 @@
       end if
       jux=jumpx
+  ! Precalculate pressure values for efficiency
+      do kl=1,nuvz
+        ppml(kl)=akz(kl)+bkz(kl)*ps(ix,jy,1,n)
+      end do
   !
   ! Loop over the vertical
@@ -120,5 +115,6 @@
 
       do kl=1,nuvz
-        theta=tth(ix,jy,kl,n)*ppmk(ix,jy,kl)
+        ppmk=akz(kl)+bkz(kl)*ps(ix,jy,1,n)
+        theta=tth(ix,jy,kl,n)*(100000./ppmk)**kappa
         klvrp=kl+1
         klvrm=kl-1
@@ -129,7 +125,9 @@
         if (klvrp.gt.nuvz) klvrp=nuvz
         if (klvrm.lt.1) klvrm=1
-        thetap=tth(ix,jy,klvrp,n)*ppmk(ix,jy,klvrp)
-        thetam=tth(ix,jy,klvrm,n)*ppmk(ix,jy,klvrm)
-        dthetadp=(thetap-thetam)/(ppml(ix,jy,klvrp)-ppml(ix,jy,klvrm))
+        ppmk=akz(klvrp)+bkz(klvrp)*ps(ix,jy,1,n)
+        thetap=tth(ix,jy,klvrp,n)*(100000./ppmk)**kappa
+        ppmk=akz(klvrm)+bkz(klvrm)*ps(ix,jy,1,n)
+        thetam=tth(ix,jy,klvrm,n)*(100000./ppmk)**kappa
+        dthetadp=(thetap-thetam)/(ppml(klvrp)-ppml(klvrm))
 
   ! Compute vertical position at pot. temperature surface on subgrid
@@ -158,21 +156,23 @@
           kch=kch+1
           k=kup
-          thdn=tth(ivr,jy,k,n)*ppmk(ivr,jy,k)
-          thup=tth(ivr,jy,k+1,n)*ppmk(ivr,jy,k+1)
-
-
-          if (((thdn.ge.theta).and.(thup.le.theta)).or. &
-          ((thdn.le.theta).and.(thup.ge.theta))) then
-            dt1=abs(theta-thdn)
-            dt2=abs(theta-thup)
-            dt=dt1+dt2
-            if (dt.lt.eps) then   ! Avoid division by zero error
-              dt1=0.5             ! G.W., 10.4.1996
-              dt2=0.5
-              dt=1.0
+          ppmk=akz(k)+bkz(k)*ps(ivr,jy,1,n)
+          thdn=tth(ivr,jy,k,n)*(100000./ppmk)**kappa
+          ppmk=akz(k+1)+bkz(k+1)*ps(ivr,jy,1,n)
+          thup=tth(ivr,jy,k+1,n)*(100000./ppmk)**kappa
+
+
+      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
+           ((thdn.le.theta).and.(thup.ge.theta))) then
+              dt1=abs(theta-thdn)
+              dt2=abs(theta-thup)
+              dt=dt1+dt2
+              if (dt.lt.eps) then   ! Avoid division by zero error
+                dt1=0.5             ! G.W., 10.4.1996
+                dt2=0.5
+                dt=1.0
+              endif
+          vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
+              goto 20
             endif
-            vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
-            goto 20
-          endif
 41        continue
   ! Downward branch
@@ -181,21 +181,23 @@
           kch=kch+1
           k=kdn
-          thdn=tth(ivr,jy,k,n)*ppmk(ivr,jy,k)
-          thup=tth(ivr,jy,k+1,n)*ppmk(ivr,jy,k+1)
-
-          if (((thdn.ge.theta).and.(thup.le.theta)).or. &
-          ((thdn.le.theta).and.(thup.ge.theta))) then
-            dt1=abs(theta-thdn)
-            dt2=abs(theta-thup)
-            dt=dt1+dt2
-            if (dt.lt.eps) then   ! Avoid division by zero error
-              dt1=0.5             ! G.W., 10.4.1996
-              dt2=0.5
-              dt=1.0
+          ppmk=akz(k)+bkz(k)*ps(ivr,jy,1,n)
+          thdn=tth(ivr,jy,k,n)*(100000./ppmk)**kappa
+          ppmk=akz(k+1)+bkz(k+1)*ps(ivr,jy,1,n)
+          thup=tth(ivr,jy,k+1,n)*(100000./ppmk)**kappa
+
+      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
+           ((thdn.le.theta).and.(thup.ge.theta))) then
+              dt1=abs(theta-thdn)
+              dt2=abs(theta-thup)
+              dt=dt1+dt2
+              if (dt.lt.eps) then   ! Avoid division by zero error
+                dt1=0.5             ! G.W., 10.4.1996
+                dt2=0.5
+                dt=1.0
+              endif
+          vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
+              goto 20
             endif
-            vx(ii)=(vvh(ivr,jy,k)*dt2+vvh(ivr,jy,k+1)*dt1)/dt
-            goto 20
-          endif
-          goto 40
+            goto 40
   ! This section used when no values were found
 21      continue
@@ -234,19 +236,21 @@
           kch=kch+1
           k=kup
-          thdn=tth(ix,j,k,n)*ppmk(ix,j,k)
-          thup=tth(ix,j,k+1,n)*ppmk(ix,j,k+1)
-          if (((thdn.ge.theta).and.(thup.le.theta)).or. &
-          ((thdn.le.theta).and.(thup.ge.theta))) then
-            dt1=abs(theta-thdn)
-            dt2=abs(theta-thup)
-            dt=dt1+dt2
-            if (dt.lt.eps) then   ! Avoid division by zero error
-              dt1=0.5             ! G.W., 10.4.1996
-              dt2=0.5
-              dt=1.0
+          ppmk=akz(k)+bkz(k)*ps(ix,j,1,n)
+          thdn=tth(ix,j,k,n)*(100000./ppmk)**kappa
+          ppmk=akz(k+1)+bkz(k+1)*ps(ix,j,1,n)
+          thup=tth(ix,j,k+1,n)*(100000./ppmk)**kappa
+      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
+           ((thdn.le.theta).and.(thup.ge.theta))) then
+              dt1=abs(theta-thdn)
+              dt2=abs(theta-thup)
+              dt=dt1+dt2
+              if (dt.lt.eps) then   ! Avoid division by zero error
+                dt1=0.5             ! G.W., 10.4.1996
+                dt2=0.5
+                dt=1.0
+              endif
+              uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
+              goto 50
             endif
-            uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
-            goto 50
-          endif
 71        continue
   ! Downward branch
@@ -255,25 +259,27 @@
           kch=kch+1
           k=kdn
-          thdn=tth(ix,j,k,n)*ppmk(ix,j,k)
-          thup=tth(ix,j,k+1,n)*ppmk(ix,j,k+1)
-          if (((thdn.ge.theta).and.(thup.le.theta)).or. &
-          ((thdn.le.theta).and.(thup.ge.theta))) then
-            dt1=abs(theta-thdn)
-            dt2=abs(theta-thup)
-            dt=dt1+dt2
-            if (dt.lt.eps) then   ! Avoid division by zero error
-              dt1=0.5             ! G.W., 10.4.1996
-              dt2=0.5
-              dt=1.0
+          ppmk=akz(k)+bkz(k)*ps(ix,j,1,n)
+          thdn=tth(ix,j,k,n)*(100000./ppmk)**kappa
+          ppmk=akz(k+1)+bkz(k+1)*ps(ix,j,1,n)
+          thup=tth(ix,j,k+1,n)*(100000./ppmk)**kappa
+      if (((thdn.ge.theta).and.(thup.le.theta)).or. &
+           ((thdn.le.theta).and.(thup.ge.theta))) then
+              dt1=abs(theta-thdn)
+              dt2=abs(theta-thup)
+              dt=dt1+dt2
+              if (dt.lt.eps) then   ! Avoid division by zero error
+                dt1=0.5             ! G.W., 10.4.1996
+                dt2=0.5
+                dt=1.0
+              endif
+              uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
+              goto 50
             endif
-            uy(jj)=(uuh(ix,j,k)*dt2+uuh(ix,j,k+1)*dt1)/dt
-            goto 50
-          endif
-          goto 70
+            goto 70
   ! This section used when no values were found
 51      continue
   ! Must use uu at current level and lat. juy becomes smaller by 1
-          uy(jj)=uuh(ix,jy,kl)
-          juy=juy-1
+        uy(jj)=uuh(ix,jy,kl)
+        juy=juy-1
   ! Otherwise OK
 50        continue
